/**************---< TECHNO ROAD.inc >---**************/
/*                                                   */
/*   File        :coron_sdwav.c                      */
/*   Version     :v3.0.0                             */
/*   Date        :2014/05/09                         */
/*   Author      :                                   */
/*   Description :SD "WAV"play Library Source        */
/*                                                   */
/*    Copyright(C) TECHNO ROAD Inc.                  */
/*                 http://techno-road.com/           */
/*****************************************************/
#include "coron_conf.h"
#ifdef _CORON_SD
#ifdef _CORON_SOUND
/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_lib.h"
#include "coron_lib.h"

/* Global variables ----------------------------------------------------------*/
u32	sound_sector=0;			//WAVt@CfBNg̃ZN^ԍ
u32 wav_sector_num[50];		//eWAVt@C̃ZN^ԍ
u32 wav_size[50];			//WAVt@C̃TCY
char wav_name[50][8];		//WAVt@C̖O
u8 wav_count;				//"SoundData"tH_WAVt@C̐
u8 now_wav_num=0;			//ĐWAVt@C̔ԍ

//==============================================================================
// SDJ[hWAVt@C
//==============================================================================
void SD_search_wav(void){
	sound_sector=SD_searchDirectory("SOUNDD");
	wav_count=SD_getFileList(sound_sector,"WAV",wav_name,wav_sector_num,wav_size);
}

//==============================================================================
// SDJ[hWAVt@CĐ(ZN^ԍ)
//==============================================================================
int SD_play_wav(u8 wav_num){
	u32 size;
	u32 sct,sec_num,i;
	u32 last_byte_num;
	size =wav_size[wav_num];
	sct  =wav_sector_num[wav_num];

	if(sound_flag != 0){
		return -(int)now_wav_num;
	}
	sound_flag = 1;
	now_wav_num = wav_num;

	/* TIM5 enable counter */
	TIM_Cmd(TIM5, ENABLE);
	//WAVt@Cf[^ZN^|1
	sec_num=(size/512);
	//Ō̃ZN^̃oCg|1
	last_byte_num=(size%512)-1;

	//ŏ̃ZN^wb_΂
	SD_read(sct*512);
    for(i=0;i<0x3a;i++){sound_buf[0][i]=0x80;}
    for(i=0x3a;i<512;i++){sound_buf[0][i]=buf512[i];}

    //Qڈȍ~̃ZN^ǂݍ
    SPK_set_sector_info(sct, sec_num, last_byte_num);
    TIM_Cmd(TIM8, ENABLE);
    return 1;
}

//==============================================================================
// SDJ[hWAVt@C~
//==============================================================================
void SD_stop_wav(void){
	TIM_Cmd(TIM5, DISABLE);
	TIM_Cmd(TIM8, DISABLE);
	sound_flag=0;
	sound_buf0_count = 0;
	sound_buf1_count = 0;
}

//==============================================================================
// SDJ[hĐWAVt@C̔ԍ擾
//==============================================================================
int SD_nowPlaying_wav(void){
	if(sound_flag == 0){
		return -1;
	}
	return now_wav_num;
}

#endif
#endif
